import React from 'react';
import './ablt.less';
import ajax from 'jquery/src/ajax/xhr.js'
import $ from 'jquery/src/ajax';
import { Input, Button, Spin, message } from 'antd';

const Base = React.createClass({
    getInitialState() {
        return {
            loading: false,
            tags: []
        };
    },
    componentWillMount() {
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            url: globalConfig.context + "/api/admin/able",
            data: {
                uid: this.props.data.uid
            },
            success: function (data) {
                if (data.data) {
                    this.setState({
                        intellectRight: data.data.intellectRight,
                        scienceAchievement: data.data.scienceAchievement,
                        researchInnovation: data.data.researchInnovation,
                        personnel: data.data.personnel
                    });
                } else if (data.error && data.error.length) {
                    message.warning(data.error[0].message);
                };
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    submit() {
        let theTags = this.state.tags.join(",");
        this.setState({
            loading: true
        })
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/disposeAble",
            data: {
                uid:this.props.data.uid,
                intellectRight: this.state.intellectRight,
                scienceAchievement: this.state.scienceAchievement,
                researchInnovation: this.state.researchInnovation,
                personnel: this.state.personnel

            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('保存成功！');
            } else {
                message.warning(data.error[0].message);
            }
        }.bind(this)).always(function () {
            this.setState({
                loading: false
            })
        }.bind(this));
    },
    render() {
        return (
            <Spin spinning={this.state.loading} className='spin-box'>
                <div className="set-ablt">
                    <div className="acc-detail clearfix">
                        <p className="acc-title">能力标签</p>
                        <div className="acc-area">
                            <p>知识产权对企业竞争力的作用 (限400字) </p>
                            <Input type="textarea" rows={6}
                                value={this.state.intellectRight}
                                onChange={(e) => {
                                    if (e.target.value.length > 400) {
                                        message.warning("长度超过400字！");
                                        return;
                                    };
                                    this.setState({ intellectRight: e.target.value });
                                }} />
                        </div>
                        <div className="acc-area">
                            <p>科技成果转化情况 (限400字) </p>
                            <Input type="textarea" rows={6}
                                value={this.state.scienceAchievement}
                                onChange={(e) => {
                                    if (e.target.value.length > 400) {
                                        message.warning("长度超过400字！");
                                        return;
                                    };
                                    this.setState({ scienceAchievement: e.target.value })
                                }} />
                        </div>
                        <div className="acc-area">
                            <p>研究开发与技术创新组织管理情况 (限400字) </p>
                            <Input type="textarea" rows={6}
                                value={this.state.researchInnovation}
                                onChange={(e) => {
                                    if (e.target.value.length > 400) {
                                        message.warning("长度超过400字！");
                                        return;
                                    };
                                    this.setState({ researchInnovation: e.target.value })
                                }} />
                        </div>
                        <div className="acc-area">
                            <p>管理与科技人员情况 (限400字) </p>
                            <Input type="textarea" rows={6}
                                value={this.state.personnel}
                                onChange={(e) => {
                                    if (e.target.value.length > 400) {
                                        message.warning("长度超过400字！");
                                        return;
                                    };
                                    this.setState({ personnel: e.target.value })
                                }} />
                        </div>
                    </div>
                    <Button className="set-submit" type="primary" onClick={this.submit}>保存</Button>
                </div>
            </Spin>
        )
    }
});

export default Base;